#include <iostream>
#include <thread>
#include <vector>

using namespace std;

const long long NUM_THREADS = 16;
const long long RANGE = 1000000;
long long result = 0;

/*
t1 (1 ... 100)
0 + 1 = 1
result = 1

t2 (100 ... 200)
0 + 100 = 100
reslut = 100

*/

/*
t1 (1 ..23. 100)
(45 + 23)

t2 (100 .111.. 200)
(45 + 111)

t1 (1 ..23. 100)
(45 + 23) = 68
result = 68

t2 (100 .111.. 200)
(45 + 111) = 156
result = 156
*/


void partial_sum(long long start, long long end) {
    for (long long i = start; i <= end; ++i) {
        result += i;
    }
}

int main() {
    vector<thread> threads;
    long long chunk_size = RANGE / NUM_THREADS;
    
    for (long long i = 0; i < NUM_THREADS; ++i) {
        long long start = i * chunk_size + 1;
        long long end = (i + 1) * chunk_size;
        threads.emplace_back(partial_sum, start, end);
    }
    
    for (auto &t : threads) {
        t.join();
    }
    
    cout << "Total Sum: " << result << endl;
    return 0;
}
