#include <iostream>
#include <thread>
#include <vector>
#include <mutex>

using namespace std;

const long long NUM_THREADS = 16;
const long long RANGE = 1000000;
long long result = 0;
mutex mu;

void partial_sum(long long start, long long end) {
    for (long long i = start; i <= end; ++i) {
        mu.lock();
        result += i;
        mu.unlock();
    }
}

int main() {
    vector<thread> threads;
    long long chunk_size = RANGE / NUM_THREADS;
    
    for (long long i = 0; i < NUM_THREADS; ++i) {
        long long start = i * chunk_size + 1;
        long long end = (i + 1) * chunk_size;
        threads.emplace_back(partial_sum, start, end);
    }
    
    for (auto &t : threads) {
        t.join();
    }
    
    cout << "Total Sum: " << result << endl;
    return 0;
}
